searchNodes=[{"doc":"Generate code from an Open API description This task requires two arguments: The configuration profile to use, and The location of the OpenAPI description. The description location can be given as an absolute path or a path relative to the Mix project where this task is run. Example mix api.gen default ../rest-api-description/spec.yaml","ref":"Mix.Tasks.Api.Gen.html","title":"Mix.Tasks.Api.Gen","type":"task"},{"doc":"Code generator for OpenAPI REST API descriptions This module provides a single function, run/2 , that accepts the name of an OpenAPI description file and configuration. It does the work of reading the description, processing schemas and operations, and writing out generated files. For a list of valid options to pass as configuration, see OpenAPI.Config .","ref":"OpenAPI.html","title":"OpenAPI","type":"module"},{"doc":"Read the OpenAPI description at filename and generate code according to config .","ref":"OpenAPI.html#run/2","title":"OpenAPI.run/2","type":"function"},{"doc":"Configuration for the code generator Configuration This section is an overview of the available configuration options. For a more in-depth discussion of output module naming, see Naming below. See also type t:t() below for the exact type specification of each option. base_location (string, required ): Relative path (from the base of the Mix project where the code generator is run) to output files. When creating a standalone client library, this will often be lib/ . base_module (module, required ): Base module for all output files. For example, a base module of Example will output schemas like Example.MySchema and operation files like Example.MyOperations . When outputting a standalone client library, this will often be the base module of the library. default_client (module): Module to call when making a web request. This code generator has no opinion on how HTTP requests are made. Instead, you must provide a client module that implements a request/1 function and performs the request and decodes the response. By default, a module [base_module].Client will be used. extra_fields (keyword list): Additional fields to add to each schema. The key is the name of the field, and the value is the type (as defined by type/0 . For example, [__info__: :map] will add a field named __info__ with type map to every schema. This can be useful for library authors that would like to store additional information in the structs returned by the client operations. Defaults to [] . group (list of modules): Namespaces to use when grouping modules. For example, two schemas SchemaOne and SchemaTwo grouped by the Schema module would become Schema.One and Schema.Two . Defaults to no grouping. ignore (list of modules, strings, or regular expressions): Schemas to ignore when outputting well-defined Elixir structs. Schemas that are ignored will be replaced with a map type when referenced elsewhere in the code. When provided as a module or string, the ignore pattern must exactly match the name of the schema after any merges . Defaults to no schemas ignored. merge (list of two-tuples): Source and destination modules for schemas that should be merged into a single file. See Merging below for examples. Defaults to no schemas merged. operation_default_module (module): Module name that will be appended to the base_module when generating operation modules and the operation has no tags or operation_use_tags is set to false . Defaults to Operation . See Operations below for details on operations generation. operation_location (string): Relative path, after the base_location , to output operation files. This may useful if you want to hide generated operation files in a subdirectory of a larger project. Defaults to outputting operation files to the base_location . operation_use_tags (boolean): Whether to use OpenAPI specification tags when generating the operation modules names. Defaults to true . See Operations below for details on operation generation. rename (list of rename pattern and action tuples): Renaming actions to take on schema names. The two elements of each tuple will be fed as the second and third arguments to String.replace/4 along with the schema name. See Renaming below for examples. Defaults to no schemas renamed. schema_location (string): Relative path, after the base_location , to output schema files. This may useful if you want to hide generated schema files in a subdirectory of a larger project. Defaults to outputting schema files to the base_location . :schema_use (module): Optional module that should be included in a use [Module] statement in each schema. This allows library authors to implement a __using__/1 macro with additional functionality. The __using__/1 macro currently does not receive any options, but it may in the future. Defaults to nil , meaning no use statement is included. types (keyword list): Overrides to the types defined by the generator. Each value should be a tuple {module, type} such as {MyModule, :t} . error : Override the error type for all operations. APIs often define their own error schemas, which may differ between operations. Use this option to define a single, consistent error type for all operations. For example, a value {MyError, :t} would cause operations to return {:ok, ...} | {:error, MyError.t()} . Naming Most of the configuration of this project relates to the manipulation of schema names. It is important to understand the order of operations. As an example, imagine an OpenAPI description has the following schemas: #/components/schemas/simple-user #/components/schemas/user #/components/schemas/user-preferences And the following configuration: config :oapi_generator , default : [ base_location : &quot;lib/&quot; , base_module : Example , group : [ User ] , ignore : [ ] , merge : [ { &quot;SimpleUser&quot; , &quot;User&quot; } ] rename : [ { ~r/Preferences/ , &quot;Settings&quot; } ] ] In this case, naming would proceed as follows: Schemas in the OpenAPI descriptions are turned into Elixir modules: #/components/schemas/simple-user =&gt; SimpleUser.t() #/components/schemas/user =&gt; User.t() #/components/schemas/user-preferences =&gt; UserPreferences.t() Merge settings are applied based on the original names of the schemas: SimpleUser . t ( ) =&gt; User . simple ( ) Ignore settings are applied based on the merged module names (no changes in this example). Rename settings are applied based on the merged module names: UserPreferences . t ( ) =&gt; UserSettings . t ( ) Group settings are applied based on the renamed module names: UserSettings . t ( ) =&gt; User.Settings . t ( ) The base module is applied to get the final names: User . simple ( ) =&gt; Example.User . simple ( ) User . t ( ) =&gt; Example.User . t ( ) User.Settings . t ( ) =&gt; Example.User.Settings . t ( ) All of the schemas are then written to appropriate files based on the base_location and schema_location settings. Note that User.simple() and User.t() will end up in the same file as a result of the merge, sharing the same struct for their responses (with distinct typespecs). Merging OpenAPI descriptions may have multiple schemas that are closely related or even duplicated. Merging gives the power to consolidate these schemas into a single struct that is easy to use. For example, the GitHub API description has schemas repository , full-repository , and nullable-repository . While the &quot;full&quot; repository adds additional properties, the &quot;nullable&quot; variant is just that: all of the same properties, but the schema is nullable. This kind of oddity in the OpenAPI specification is exactly what makes most generated code difficult to use. The following merge settings would help clean this up: merge : [ { &quot;FullRepository&quot; , &quot;Repository&quot; } , { ~r/^Nullable/ , &quot;&quot; } ] In the first line, we tell the generator to merge FullRepository into Repository (the original module names based on the names of the schemas). Because the destination module appears at the end of the original module, the word &quot;Repository&quot; will be dropped from the type: FullRepository =&gt; Repository :: Repository . full ( ) This renaming of the type is automatic for prefixes and suffixes. If no overlap is found, then the full (underscored) schema name will be used for the type: SimpleUser =&gt; User :: User . simple ( ) PullRequestSimple =&gt; PullRequest :: PullRequest . simple ( ) MySchema =&gt; Unrelated :: Unrelated . my_schema ( ) If the destination module is later renamed or grouped, the merged schemas will processed in the same way. Collapsing In the second line of the configuration above, we merge two nearly-identical schemas NullableRepository and Repository . Because these schemas have the same fields, there will not be a Repository.nullable() type generated; instead, references will use Repository.t() . Despite this deduplication, other parts of the code will continue to know that the original schema had nullable: true and respond accordingly. Ignoring Sometimes, schemas are best treated as plain maps. In these cases, they can be ignored using a regular expression, exact string, or exact module: ignore : [ ~r/^Unnecessary/ , &quot;SomeSchema&quot; , AnotherSchema ] Any references to an ignored schema will be replaced with a map() type. Grouping Schemas in an OpenAPI description can have extensively long names. For example, GitHub has a schema called actions-cache-usage-by-repository . Along with all other actions-related schemas, we can cut down the top-level module namespace by grouping on Actions or even further: group : [ Actions , Actions.CacheUsage ] Even simple renaming and groups can take a raw OpenAPI description and turn it into a library that feels friendly to users. Operations Operations are the API entrypoint, which normally will be called by the user of the library. This generator generates a set of modules with functions in them according to some normalization rules: Operation tags and IDs will be normalized for spaces, slashes, etc. Operation tags will be used to generate modules that group operation functions Operations with slashes will be split, with each component used to generate the module hierarchy of the operation Examples: Operation foo with tag bar =&gt; Bar.foo Operation foo/bar with tag baz =&gt; Baz.foo_bar Operation foo/bar without tags =&gt; Foo.bar Further examples can be found in the tests for OpenAPI.Generator.OperationTest.names/1 . To summarize, the generator uses tags to create modules containing the operation functions. If tags are not present, module names will be created from the operation's ID if it contains slashes. If the operation has no slashes and no tags, the generator cannot infer a proper module name. That's where the operation_default_module config option comes in place. For such operations, the operation_default_module will be used as container for the operation. Examples: Operation foo without tags =&gt; [base_module].Operation.foo Since OpenAPI tags are not strictly part of the specification, you can also decide to not use them at all with the option operation_use_tags set to false . This will put all operations into a single module specified by operation_default_module . There's no risk of functions conflict since by definition operation IDs are unique on a given OpenAPI specification.","ref":"OpenAPI.Config.html","title":"OpenAPI.Config","type":"module"},{"doc":"Keyword list of extra fields to add to each schema","ref":"OpenAPI.Config.html#t:extra_fields/0","title":"OpenAPI.Config.extra_fields/0","type":"type"},{"doc":"List of module namespaces to create when grouping","ref":"OpenAPI.Config.html#t:group_options/0","title":"OpenAPI.Config.group_options/0","type":"type"},{"doc":"List of patterns or exact matches of schemas to ignore","ref":"OpenAPI.Config.html#t:ignore_options/0","title":"OpenAPI.Config.ignore_options/0","type":"type"},{"doc":"Patterns or exact matches of schemas to ignore","ref":"OpenAPI.Config.html#t:ignore_pattern/0","title":"OpenAPI.Config.ignore_pattern/0","type":"type"},{"doc":"Before (pattern or exact match) and after (replacement action) for merging schemas by module","ref":"OpenAPI.Config.html#t:merge_options/0","title":"OpenAPI.Config.merge_options/0","type":"type"},{"doc":"Replacement action for renaming schemas by module","ref":"OpenAPI.Config.html#t:rename_action/0","title":"OpenAPI.Config.rename_action/0","type":"type"},{"doc":"List of replacement searches and actions for renaming schemas by module","ref":"OpenAPI.Config.html#t:rename_options/0","title":"OpenAPI.Config.rename_options/0","type":"type"},{"doc":"Search pattern for renaming schemas by module","ref":"OpenAPI.Config.html#t:rename_pattern/0","title":"OpenAPI.Config.rename_pattern/0","type":"type"},{"doc":"Configuration for the code generator","ref":"OpenAPI.Config.html#t:t/0","title":"OpenAPI.Config.t/0","type":"type"},{"doc":"Runtime type annotation","ref":"OpenAPI.Config.html#t:type/0","title":"OpenAPI.Config.type/0","type":"type"},{"doc":"A highly-configurable code generator that combines ergonomics with maintainability. OpenAPI is a standard way to describe REST APIs on the web. Anyone can create an OpenAPI description document that includes the available endpoints, expected request data, and possible responses. For example, GitHub maintains a comprehensive OpenAPI description for their services. Generating code from an OpenAPI description can be relatively easy — this project certainly isn't the first — but there's a catch: API descriptions often don't translate into ergonomic code. Most users of an API client library don't want to think about the difference between a NullableRepository and Repository , as in the OpenAPI 3.0 GitHub API description. (They have the same fields, but one has nullable: true .) Users just want to get back a %Repository{} or nil . The goal of this library is to create ergonomic client libraries from OpenAPI descriptions. At the same time, the changes made to the code are easily repeatable (fully automated) for the sake of maintainability. Think: the friendliness of your favorite hand-crafted client library applied to the scale of large APIs. See an example client library here . For more on how this is accomplished, see Configuration below.","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"This library is available on Hex.pm. Add the dependency in mix.exs : def deps do [ { :oapi_generator , &quot;~&gt; 0.0.7&quot; } ] end Then install the dependency using mix deps.get .","ref":"readme.html#installation","title":"Overview - Installation","type":"extras"},{"doc":"The real power of this library is in the available configuration. Although the options are conceptually simple, they add up to a better user experience. This project uses configuration profiles to allow multiple configurations with the same package. To get started, create a profile called default in your configuration: config :oapi_generator , default : [ base_location : &quot;lib/example&quot; , base_module : Example ] This is the minimum viable configuration for the generator. It will create modules namespaced with Example. and save files in lib/example . For a full list of configuration options, see the documentation for OpenAPI.Config . Output Module Naming When the generator encounters a schema in the OpenAPI description, it performs a number of steps to determine the final name (module and type) of the schema that will be output to a file: Based on the schema's location in the document, a provisional name is assigned. For example, #/components/schemas/full-repository becomes FullRepository.t() . Schemas are merged based on the merge configuration key. For example, you may choose to merge FullRepository.t() into the Repository.t() schema to create Repository.full() . If two merged schemas have identical fields, then they will get the same name. Schemas can be ignored using the ignore configuration key. Ignored schemas will be typed as simple map() types elsewhere in the generated code. Schemas can be renamed using the rename configuration key. For example, you may wish to add or remove a word, change plurality, etc. Finally, schemas can be grouped using the group configuration key. For example, a group of Repository would change RepositoryInvitation to Repository.Invitation . The final module and type will be consistent in the output schema files and other files that reference them. The config/config.exs file for this repository contains an example configuration related to the GitHub API description. It includes a large number of groups for easily readable module names, merges for repeated or highly related schemas, and some module renaming for ease-of-use.","ref":"readme.html#configuration","title":"Overview - Configuration","type":"extras"},{"doc":"Once the library is installed and configured, use mix api.gen with the name of the configuration profile and the OpenAPI description file: mix api.gen default ../rest-api-description/spec.yaml","ref":"readme.html#usage","title":"Overview - Usage","type":"extras"},{"doc":"Code of Conduct Contribution Guidelines License OpenAPI Specification","ref":"readme.html#further-reading","title":"Overview - Further Reading","type":"extras"},{"doc":"If you like this library or it makes you money, please consider sponsoring .","ref":"readme.html#sponsorship","title":"Overview - Sponsorship","type":"extras"},{"doc":"","ref":"code_of_conduct.html","title":"Code of Conduct","type":"extras"},{"doc":"We as members, contributors, and leaders pledge to make participation in our community a harassment-free experience for everyone, regardless of age, body size, visible or invisible disability, ethnicity, sex characteristics, gender identity and expression, level of experience, education, socio-economic status, nationality, personal appearance, race, caste, color, religion, or sexual identity and orientation. We pledge to act and interact in ways that contribute to an open, welcoming, diverse, inclusive, and healthy community.","ref":"code_of_conduct.html#our-pledge","title":"Code of Conduct - Our Pledge","type":"extras"},{"doc":"Examples of behavior that contributes to a positive environment for our community include: Demonstrating empathy and kindness toward other people Being respectful of differing opinions, viewpoints, and experiences Giving and gracefully accepting constructive feedback Accepting responsibility and apologizing to those affected by our mistakes, and learning from the experience Focusing on what is best not just for us as individuals, but for the overall community Examples of unacceptable behavior include: The use of sexualized language or imagery, and sexual attention or advances of any kind Trolling, insulting or derogatory comments, and personal or political attacks Public or private harassment Publishing others' private information, such as a physical or email address, without their explicit permission Other conduct which could reasonably be considered inappropriate in a professional setting","ref":"code_of_conduct.html#our-standards","title":"Code of Conduct - Our Standards","type":"extras"},{"doc":"Community leaders are responsible for clarifying and enforcing our standards of acceptable behavior and will take appropriate and fair corrective action in response to any behavior that they deem inappropriate, threatening, offensive, or harmful. Community leaders have the right and responsibility to remove, edit, or reject comments, commits, code, wiki edits, issues, and other contributions that are not aligned to this Code of Conduct, and will communicate reasons for moderation decisions when appropriate.","ref":"code_of_conduct.html#enforcement-responsibilities","title":"Code of Conduct - Enforcement Responsibilities","type":"extras"},{"doc":"This Code of Conduct applies within all community spaces, and also applies when an individual is officially representing the community in public spaces. Examples of representing our community include using an official e-mail address, posting via an official social media account, or acting as an appointed representative at an online or offline event.","ref":"code_of_conduct.html#scope","title":"Code of Conduct - Scope","type":"extras"},{"doc":"Instances of abusive, harassing, or otherwise unacceptable behavior may be reported to the community leaders responsible for enforcement by email . All complaints will be reviewed and investigated promptly and fairly. All community leaders are obligated to respect the privacy and security of the reporter of any incident.","ref":"code_of_conduct.html#enforcement","title":"Code of Conduct - Enforcement","type":"extras"},{"doc":"Community leaders will follow these Community Impact Guidelines in determining the consequences for any action they deem in violation of this Code of Conduct: 1. Correction Community Impact : Use of inappropriate language or other behavior deemed unprofessional or unwelcome in the community. Consequence : A private, written warning from community leaders, providing clarity around the nature of the violation and an explanation of why the behavior was inappropriate. A public apology may be requested. 2. Warning Community Impact : A violation through a single incident or series of actions. Consequence : A warning with consequences for continued behavior. No interaction with the people involved, including unsolicited interaction with those enforcing the Code of Conduct, for a specified period of time. This includes avoiding interactions in community spaces as well as external channels like social media. Violating these terms may lead to a temporary or permanent ban. 3. Temporary Ban Community Impact : A serious violation of community standards, including sustained inappropriate behavior. Consequence : A temporary ban from any sort of interaction or public communication with the community for a specified period of time. No public or private interaction with the people involved, including unsolicited interaction with those enforcing the Code of Conduct, is allowed during this period. Violating these terms may lead to a permanent ban. 4. Permanent Ban Community Impact : Demonstrating a pattern of violation of community standards, including sustained inappropriate behavior, harassment of an individual, or aggression toward or disparagement of classes of individuals. Consequence : A permanent ban from any sort of public interaction within the community.","ref":"code_of_conduct.html#enforcement-guidelines","title":"Code of Conduct - Enforcement Guidelines","type":"extras"},{"doc":"This Code of Conduct is adapted from the Contributor Covenant , version 2.1, available at https://www.contributor-covenant.org/version/2/1/code_of_conduct.html . Community Impact Guidelines were inspired by Mozilla's code of conduct enforcement ladder . For answers to common questions about this code of conduct, see the FAQ at https://www.contributor-covenant.org/faq . Translations are available at https://www.contributor-covenant.org/translations .","ref":"code_of_conduct.html#attribution","title":"Code of Conduct - Attribution","type":"extras"},{"doc":"Hello there. Thank you for your interest in contributing to this project. With a wide variety of OpenAPI descriptions in the world, this project could use your assistance. Reading and following the guidelines in this document is an act of kindness and respect for other contributors. With your help, we can address issues, make changes, and work together efficiently.","ref":"contributing.html","title":"Contributing","type":"extras"},{"doc":"There are many ways to contribute to this project: Individuals with experience in Elixir can help us to address observed and potential issues. Users of REST APIs with OpenAPI descriptions can try the generator and report any issues or recommendations for improvement they encounter. Users of the package can help to test new use-cases and patterns. Documentation improves everyone's experience. Anyone can assist in the triage of bugs, identifying root causes, and proposing solutions. Please keep in mind the intended scope of this package: to provide a code generator that balances an ergonomic user experience with maintainability. Assume that the OpenAPI description that serves as input to this library will change often, and manually changing the output is impractical.","ref":"contributing.html#ways-to-contribute","title":"Contributing - Ways to Contribute","type":"extras"},{"doc":"All contributions to this project must align with the code of conduct . Beyond that, we ask: Please be kind. Maintaining this project is not paid work. Please create an issue before embarking on major refactors or new features. Let's make reasonable effort to support as many OpenAPI descriptions as possible.","ref":"contributing.html#ground-rules","title":"Contributing - Ground Rules","type":"extras"},{"doc":"If you find a security-related issue with this project, please refrain from opening a public issue and instead email the maintainer .","ref":"contributing.html#security-issues","title":"Contributing - Security Issues","type":"extras"},{"doc":"For maintainers, the process of releasing this package to Hex.pm centers around git tags. To make a new release: Update the Changelog with a new header that has today's date and the new version. Include any missing notes from changes since the last release, and any additional upgrade instructions users may need. Update the @version number in mix.exs . The form should be X.Y.Z , with optional suffixes, but no leading v . Update the Installation instructions in README.md to have the newest non-suffixed version number. Commit the above changes with a generic commit message, such as Release X.Y.Z . Tag the commit as X.Y.Z , with optional suffixes, but no leading v . Push the commits and tag (for example, git push origin main --tags ). Observe the GitHub Action titled Release . This action automatically publishes the package to Hex.pm.","ref":"contributing.html#releases","title":"Contributing - Releases","type":"extras"},{"doc":"MIT License Copyright (c) 2022 AJ Foster Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"License","type":"extras"},{"doc":"Unlike most packages on Hex.pm, the target audience for this project is other library authors , and not necessarily end-users. While it is certainly possible for application developers to generate code directly in their Elixir apps, it's likely that most OpenAPI specifications will be consumed by a generic client library (like oapi_github ) instead. With that in mind, this guide provides additional information and guidance for authors of client libraries.","ref":"client-author-guide.html","title":"Client Author Guide","type":"extras"},{"doc":"As the author of a library with code generated from an OpenAPI description, it's important to establish a healthy relationship between your library and the spec. For example, if your library is based on a specification that is updated often, you likely want to set a reasonable cadence (ex. monthly) for updating the generated code. Otherwise, maintenance can become a burden very quickly. Following are some recommendations for how to establish this relationship. Cadence As mentioned above, some OpenAPI descriptions are updated often. Before introducing API versioning, GitHub continuously updated its OpenAPI spec with both new endpoints and corrections for existing ones. A library author could potentially release new versions every week in an attempt to keep up. However, it's unlikely that real-time updates of the generated code is necessary. Here are a few options for releasing updates to the generated code: If the description updates often with new endpoints that consumers of your library are eager to use, a rapid or as-needed release cadence may be appropriate. This might mean creating a scheduled CI job that regularly re-generates the code based on the latest copy of the specification and opens a pull request with the changes. Or, it might mean encouraging users of the library to open an issue or pull request when they encounter an unsupported endpoint. If the description updates often with fixes to the specification, then a periodic release cadence may be appropriate. This would help users of the library avoid issues while also reducing the maintenance burden. If the description has well-versioned or occasional updates, the client may wish to &quot;follow&quot; the release cadence of the specification. In this case, the version of the description may play a central role in the client, and should likely be included as an .api-version file in the release. This makes it clear to users of the library what API version they can expect. Contributions Some libraries will be best served by an as-needed update cadence. In this case, simple guidelines around the contribution of generated code can make a big difference. Here is an excerpt from the contribution guidelines for the GitHub client library that uses this generator: Updating the Generated Code If you intend to open a PR with updates to the generated code based on the latest GitHub OpenAPI description, please read carefully: Please use the latest commit from the official repository at the time of your contribution. Please use descriptions-next/api.github.com/api.github.com.yaml — not descriptions or a GitHub Enterprise release. Use mix api.gen default path/to/descriptions-next/api.github.com/api.github.com.yaml to regenerate the code. Please also change the .api-version file if appropriate. Please include the commit SHA of the official repository in the description of your pull request. Please do not make any other changes in the same PR (for example, changing this library's version). If you run into any unexpected issues while generating the code, please open an issue. Thank you for your help! Although not all contributors will read this guidance, steps like this can make it much easier for you as a library author to simply merge the pull request and release a new version. Supplemental Specs Despite best efforts, OpenAPI descriptions often don't cover all of the API endpoints available. For example, although GitHub provides a nearly-comprehensive specification of hundreds of endpoints, there are ID-based endpoints like /repositories/{id} that are not publicly documented. A library author may know this a priori and wish to include these endpoints in the generated code. For this case, it is recommended that the author maintain a separate, supplemental OpenAPI description document with just enough information to generate the additional code.","ref":"client-author-guide.html#code-generation","title":"Client Author Guide - Code Generation","type":"extras"},{"doc":"This project exists for its configuration capabilities. Most API client libraries are either feature complete (due to code generation) or ergonomic (due to hand-crafting code), but not both. With the right configuration — and a little bit of luck with the OpenAPI description — your client library can be both. Operations Operations are the actions you can take in an API: the actual HTTP requests that are possible. This code generator takes an operation-first mindset when generating code. For example, schemas that are defined in a description but not referenced in any API operation will not be output. At the moment, configuration related to the naming and placement of operation functions is limited. If you have ideas related to this, please share them in GitHub Discussions. There are configuration options targeted at making the generated functions more flexible for library authors: Default Client default_client defines the module that will be called in each operation function. By allowing the client module to be defined at the time of code generation (with this option) and at runtime (with the client option passed to any operation call), this code generator maximizes flexibility. For example, tests can supply a special test client module when they call client operations. This need not be the end of the flexibility, however. The GitHub client library defines a &quot;stack&quot; system within its client module, allowing users to easily swap libraries for handling HTTP requests and decoding JSON. Types types , and specifically its error key, allows library authors to override the return type of operation functions. It's fairly common for client libraries to create their own error that acts as a superset for all of the errors defined in the OpenAPI description. This provides a consistent interface for client library consumers. Schemas Much of the configuration of this code generator relates to the naming and output of schemas. For more information, check out the Naming section of the OpenAPI.Config module documentation. There are also configuration options targeted at making the generated modules more flexible for library authors: Extra Fields extra_fields allows authors to insert additional fields into every outputted schema. For example, the GitHub library adds an __info__ map to each schema. Like the __meta__ field provided by Ecto.Schema or the private field on Plug.Conn , this field can hold additional library-specific information without interfering with the API's own data. Schema &quot;use&quot; schema_use allows authors to insert a use [Module] statement at the top of every schema. A corresponding module must be supplied by the library with a __using__/1 macro. Inside this macro, library authors can inject additional code that may be helpful. For example: defmodule MyLibrary.Schema do defmacro __using__ ( _opts ) do quote do @derive { Jason.Encoder , except : [ :__info__ ] } end end end Inside the macro, you can reference the name of the current module using __MODULE__ , along with any other variables that are part of the macro environment.","ref":"client-author-guide.html#configuration","title":"Client Author Guide - Configuration","type":"extras"}]